unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  synaser;

type

  { TForm1 }

  TForm1 = class(TForm)
    Bevel1: TBevel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Memo1: TMemo;
    Memo2: TMemo;
    ReceiveButton: TButton;
    SendButton: TButton;
    procedure ReceiveButtonClick(Sender: TObject);
    procedure SendButtonClick(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.SendButtonClick(Sender: TObject);
var
  ser:TBlockSerial;
  smstext : String;
  a : Integer;
begin
  memo1.lines.Clear;
  ser:=TBlockSerial.Create;
  ser.config(StrToIntDef(Edit2.Text, 9600),
    StrToIntDef(Edit3.Text, 8),
      String(ComboBox1.Items[ComboBox1.ItemIndex])[1],
        StrToIntDef(Edit4.Text, 1),not Boolean(ComboBox2.ItemIndex), Boolean(ComboBox2.ItemIndex));

  smstext := '';
  For a := 0 To Memo2.Lines.Count - 1 Do
    smstext := smstext + ' ' + Memo2.Lines[a];

  ser.RaiseExcept:=True;
  try

    ser.Connect(Edit1.Text);
    sleep(200);
    ser.ATCommand('AT+CMGF=1');        //<-- Text Mode
    sleep(200);
    ser.SendString('AT+CMGS="' + Edit5.Text + '"'+ #$0D);  //Mobil-Nr
    sleep(200);
    ser.SendString(smstext + #$1A);  //<-- Sende SMS
    sleep(200);
    memo2.lines.Add('SMS gesendet!');

  finally
    ser.free;
  end;
end;

procedure TForm1.ReceiveButtonClick(Sender: TObject);
var
  ser:TBlockSerial;
begin
  memo1.lines.Clear;
  ser:=TBlockSerial.Create;
  ser.config(StrToIntDef(Edit2.Text, 9600),
    StrToIntDef(Edit3.Text, 8),
      String(ComboBox1.Items[ComboBox1.ItemIndex])[1],
        StrToIntDef(Edit4.Text, 1),not Boolean(ComboBox2.ItemIndex), Boolean(ComboBox2.ItemIndex));

  ser.RaiseExcept:=True;
  try

    ser.Connect(Edit1.Text);
    sleep(200);
    //Setze Text-Mode
    ser.ATCommand('AT+CMGF=1');
    sleep(200);
    //Setzt den bevorzugten Speicher auf SIM-Karte.
    //mem1 ist der Speicher, aus dem Nachrichten gelesen und gelöscht werden,
    //mem2 ist der Speicher, in den geschrieben und aus dem heraus gesendet wird,
    //mem3 ist der Speicher, in dem ankommende Nachrichten abgelegt werden
    memo1.lines.add(ser.ATCommand('AT+CPMS="SM","SM","SM"'));
    sleep(200);
    //Abfrage des Speichers
    memo1.lines.add(ser.ATCommand('AT+CPMS?'));
    sleep(200);
    //Abrufen der Nachrichten
    // - Alle
    //memo1.lines.add(ser.ATCommand('AT+CMGL="ALL"'));
    //sleep(200);
    // - ungelesene
    memo1.lines.add(ser.ATCommand('AT+CMGL="REC UNREAD"'));
    sleep(200);
    // - gelesene    ( Bei mir sind auch neue Nachrichten im Speicher gelesen )
    memo1.lines.add(ser.ATCommand('AT+CMGL="REC READ"'));
    sleep(200);
  finally
    ser.free;
  end;
end;

end.

